# Sample "signal-enabled-RNG" Script for pxWorks
# Author: cloudcell
# TODO: update the sketch so it works with signals properly
#       this is not yet a fully developed prototype
#       if this RNG had a data input, then it would need to properly check
#       whether the signal file exists or not and process the signal properly
#       separately from the data inputs

if (!require("quantmod")) install.packages("quantmod")
require(quantmod) # for now, let's read from Yahoo, as an example

# Starting Up ------------------------------------------------------------------
# set working directory to the directory of the script:
 # setwd(dirname(parent.frame(2)$ofile))
message(getwd()) # shows current working directory
# stop()
# the environment creates this file ("paths.meta")
paths_to_get_input_data <- read.delim(file="paths.meta", header = F, as.is = T)
# ------------------------------------------------------------------------------

input_fp <- paths_to_get_input_data[1,]

# read input
input1 <- read.csv(file=input_fp, header = F)
file.remove(input_fp) # signal files have to be removed after reading



if(0) {
    # get data from IB and save it with the output file name
    output <- data.frame(value=1)
    colnames(output) <- input1
    # plot(output)
}


# for now, just write to log
message(input1)
e <- new.env()
getSymbols(Symbols=input1$V1, env = e)

output <- get(input1$V1,envir = e)
output <- output[,6]


# Signal Success ---------------------------------------------------------------

signal_done <- "NEXT"

# Saving Work ------------------------------------------------------------------
# The write must be an atomic operation to prevent conflicts over file
# when the file is being written to / flushed from memory to drive
write.csv(output,"tmp.output")
file.rename(from="tmp.output",to="output") # atomic operation

write.csv(signal_done,"tmp.done")
file.rename(from="tmp.done",to="done") # atomic operation

message("Done.")
# ------------------------------------------------------------------------------
