# Sample "Signal Sink" Script for pxWorks
# Author: cloudcell

# Starting Up ------------------------------------------------------------------
# set working directory to the directory of the script:
# setwd(dirname(parent.frame(2)$ofile))
message(getwd()) # shows current working directory
# stop()
# the environment creates this file ("paths.meta")
paths_to_get_input_data <- read.delim(file="paths.meta", header = F, as.is = T)
# ------------------------------------------------------------------------------

# "consume" the file from source
file.remove(paths_to_get_input_data$V1[1])

# pause for 10 seconds
Sys.sleep(10)


data <- runif(10^3)

# Saving Work ------------------------------------------------------------------
# The write must be an atomic operation to prevent conflicts over file
# when the file is being written to / flushed from memory to drive

write.csv(data,"output")
message("Done.")
# ------------------------------------------------------------------------------
